#include "testlib.h"
#include <string>
#include <vector>

struct TGroup {
    const std::string name;
    const int maxc;
};

const std::vector<TGroup> GetGroups() {
    static std::vector<TGroup> groups = {{"0", 50},
                                         {"1", 50},
                                         {"2", 1'000'000},
                                         {"3", 100'000'000}};
    return groups;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int maxc = -1;
    bool found = false;
    for (const auto& group : GetGroups()) {
        if (validator.group() == group.name) {
            found = true;
            maxc = group.maxc;
        }
    }

    ensuref(found, "Group didn't found");
    inf.readInt(1, maxc, "w1");
    inf.readEoln();
    inf.readInt(1, maxc, "h1");
    inf.readEoln();
    inf.readInt(1, maxc, "w2");
    inf.readEoln();
    inf.readInt(1, maxc, "h2");
    inf.readEoln();
    inf.readEof();
    return 0;
}

