// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>
#include "testlib.h"

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int readAns(InStream& stream, vector<int>& in) {
    vector<int> data;
    for (int i = 0; i != SZ(in); ++i)
        data.push_back(stream.readInt());

    vector<int> copy = data;
    std::sort(ALL(copy));

    if (copy != in)
        stream.quitf(_wa, "The given array doesn't correspond to the input array");

    int ans = -1;
    for (int i = 0; i != SZ(in); ++i) {
        int j = (i + 1) % SZ(in);

        ans = max(ans, abs(data[j] - data[i]));
    }

    return ans;
}

int main(int argc, char** argv) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();

    vector<int> a(n);
    for (int& elem: a)
        elem = inf.readInt();

    std::sort(ALL(a));
    
    int jury_ans = readAns(ans, a);
    int part_ans = readAns(ouf, a);

    if (jury_ans == part_ans)
        quitf(_ok, "The answer is %d", jury_ans);
    else if (jury_ans < part_ans)
        quitf(_wa, "The answer is %d, participant said it's %d", jury_ans, part_ans);
    else
        quitf(_fail, "Jury's answer was %d, but participant's answer is %d", jury_ans, part_ans);
    
    return 0;
}
