#include "testlib.h"

using namespace std;

typedef long long int ll;

struct Group {
    string name;
    int MAX_N;
    int MAX_TOTAL;
};

const int GROUP_CNT = 5;

Group groups[GROUP_CNT] = {
    {"samples", 7, 100},
    {"group1", 7, 100},
    {"group2", 15, 100 * 1000},
    {"group3", 2, -1},
    {"group4", 100 * 1000, -1}
};
const int MAX_SUM = 100 * 1000;
const int MAX_ANSWER = 1000 * 1000 * 1000;

struct state {
    char lf_symb;
    ll lf_cnt;
    char rf_symb;
    ll rf_cnt;
    ll ans;
    bool same;
};

state get_state_by_char(char c) {
    return {c, 1ll, c, 1ll, 1ll, true};
}

state merge(state lf, state rf) {
    state ans = {lf.lf_symb, lf.lf_cnt, rf.rf_symb, rf.rf_cnt, max(lf.ans, rf.ans), (lf.same && rf.same && lf.rf_symb == rf.lf_symb)};

    if (lf.rf_symb == rf.lf_symb) {
        ans.ans = max(ans.ans, lf.rf_cnt + rf.lf_cnt);
    }

    if (lf.same && lf.rf_symb == rf.lf_symb) {
        ans.lf_cnt += rf.lf_cnt;
    }

    if (rf.same && lf.rf_symb == rf.lf_symb) {
        ans.rf_cnt += lf.rf_cnt;
    }

    ensuref(ans.ans <= MAX_ANSWER, "answer is bigger than %d", MAX_ANSWER);

    return ans;
}

void check_max_ans(const vector<string>& arr) {
    state ans = get_state_by_char(arr.back()[0]);

    for (int i = 1; i < (int)arr.back().size(); ++i) {
        ans = merge(ans, get_state_by_char(arr.back()[i]));
    }

    for (int i = (int)arr.size() - 2; i >= 0; --i) {
        state tmp = ans;
        for (int j = 0; j < (int)arr[i].size(); ++j) {
            ans = merge(ans, merge(get_state_by_char(arr[i][j]), tmp));
        }
    }

    ensuref(ans.ans <= MAX_ANSWER, "answer is bigger than %d", MAX_ANSWER);
}


signed main(int argc, char **argv) {
    registerValidation(argc, argv);

    int group_id = -1;

    for (int i = 0; i < GROUP_CNT; ++i) {
        if (validator.group() == groups[i].name) {
            group_id = i;

            break;
        }
    }

    ensuref(group_id != -1, "no group for this test");

    Group cgr = groups[group_id];

    int n = inf.readInt(2, cgr.MAX_N, "n");
    inf.readEoln();

    vector<string> arr(n);
    ll sum_len = 0;
    for (int i = 0; i < n; ++i) {
        arr[i] = inf.readToken("[a-z]{1, " + vtos(MAX_SUM) + "}");
        inf.readEoln();
        sum_len += arr[i].size();
        ensuref(sum_len <= MAX_SUM, "string length sum is bigger than %d", MAX_SUM);
    }

    inf.readEof();

    if (cgr.MAX_TOTAL != -1) {
        ll total_len = 0;

        for (int i = 0; i < n; ++i) {
            total_len += (ll)arr[i].size() * (total_len + 1);

            ensuref(total_len <= cgr.MAX_TOTAL, "product string length is bigger than %d", cgr.MAX_TOTAL);
        }
    }

    check_max_ans(arr);

    return 0;
}

