#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 100 * 1000 + 228;

struct state {
    char lf_symb;
    ll lf_cnt;
    char rf_symb;
    ll rf_cnt;
    ll ans;
    bool same;
};

state get_state_by_char(char c) {
    return {c, 1ll, c, 1ll, 1ll, true};
}

state merge(state lf, state rf) {
    state ans = {lf.lf_symb, lf.lf_cnt, rf.rf_symb, rf.rf_cnt, max(lf.ans, rf.ans), (lf.same && rf.same && lf.rf_symb == rf.lf_symb)};

    if (lf.rf_symb == rf.lf_symb) {
        ans.ans = max(ans.ans, lf.rf_cnt + rf.lf_cnt);
    }

    if (lf.same && lf.rf_symb == rf.lf_symb) {
        ans.lf_cnt += rf.lf_cnt;
    }

    if (lf.rf_symb == rf.lf_symb) {
        ans.rf_cnt += lf.rf_cnt;
    }

    return ans;
}

ll solve(const vector<string>& arr) {
    state ans = get_state_by_char(arr.back()[0]);

    for (int i = 1; i < (int)arr.back().size(); ++i) {
        ans = merge(ans, get_state_by_char(arr.back()[i]));
    }

    for (int i = (int)arr.size() - 2; i >= 0; --i) {
        state tmp = ans;
        for (int j = 0; j < (int)arr[i].size(); ++j) {
            ans = merge(ans, merge(get_state_by_char(arr[i][j]), tmp));
        }
    }

    return ans.ans;
}

int n;
vector<string> arr;
char buf[MAX_N];

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%s", buf);
        arr.push_back(buf);
    }

    printf("%lld\n", solve(arr));

    return 0;
}

