#!/usr/local/bin/python3

class State(object):
    def __init__(self, lf_symb, lf_cnt, rf_symb, rf_cnt, same, ans):
        self.lf_symb = lf_symb
        self.lf_cnt = lf_cnt
        self.rf_symb = rf_symb
        self.rf_cnt = rf_cnt
        self.same = same
        self.ans = ans

    def copy(self):
        return State(self.lf_symb, self.lf_cnt, self.rf_symb, self.rf_cnt, self.same, self.ans)

    @staticmethod
    def merge(lf, rf):
        answer = State(lf.lf_symb, lf.lf_cnt, rf.rf_symb, rf.rf_cnt, lf.same and rf.same and lf.rf_symb == rf.lf_symb, max(lf.ans, rf.ans))

        if lf.rf_symb == rf.lf_symb:
            answer.ans = max(answer.ans, lf.rf_cnt + rf.lf_cnt)

        if lf.same and lf.rf_symb == rf.lf_symb:
            answer.lf_cnt += rf.lf_cnt

        if rf.same and lf.rf_symb == rf.lf_symb:
            answer.rf_cnt += lf.rf_cnt

        return answer

n = int(input())
arr = list(reversed([input() for i in range(n)]))

answer = State(arr[0][0], 1, arr[0][0], 1, True, 1)
for i in range(1, len(arr[0])):
    answer = State.merge(answer, State(arr[0][i], 1, arr[0][i], 1, True, 1))

for i in range(1, n):
    mem = answer.copy()
    for j in range(len(arr[i])):
        answer = State.merge(answer, State.merge(State(arr[i][j], 1, arr[i][j], 1, True, 1), mem))

print(answer.ans)
