#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>
#include <cassert>


using namespace std;


#define int long long


const int ALP = 26;


const int MAX = (1LL << 31);


void subtract_a(string &s) {
    for (char &c : s) {
        c -= 'a';
    }
}


inline void maxeq(int &a, int b) {
    if (b > a) {
        a = b;
    }
}


int longest_run(string &s, char c = -1) {
    s += (char)-1;

    int n = s.length();

    int answ = 0;

    char last = 0;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] != last) {
            if (c == -1 || last == c) {
                maxeq(answ, cnt);
            }

            last = s[i];
            cnt = 0;
        }

        ++cnt;
    }

    return answ;
}


bool one_char(string &s) {
    int n = s.length();

    for (int i = 0; i < n - 1; ++i) {
        if (s[i] != s[i + 1]) {
            return false;
        }
    }

    return true;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    string s;
    cin >> s;

    subtract_a(s);

    int dp[ALP];
    for (int i = 0; i < ALP; ++i) {
        dp[i] = longest_run(s, i);
    }

    string t;
    for (int cs = 0; cs < n - 1; ++cs) {
        for (int i = 0; i < ALP; ++i) {
            assert(dp[i] < MAX);
        }

        cin >> t;

        subtract_a(t);

        int m = t.length();

        if (one_char(t)) {
            char c = t[0];

            dp[c] = m * (dp[c] + 1) + dp[c];
            for (int i = 0; i < ALP; ++i) {
                if (i != c) {
                    dp[i] = (dp[i] > 0);
                }
            }

            continue;
        }

        char cl = t[0], cr = t[m - 1];

        int left_run = 0;
        for (int i = 0; t[i] == cl; ++i) {
            ++left_run;
        }

        int right_run = 0;
        for (int i = m - 1; t[i] == cr; --i) {
            ++right_run;
        }

        int tlrs[ALP];
        for (int i = 0; i < ALP; ++i) {
            tlrs[i] = longest_run(t, i);
        }

        if (cl == cr) {
            char c = cl;

            if (dp[c] > 0) {
                dp[c] = max(tlrs[c], left_run + right_run + 1);
            } else {
                dp[c] = tlrs[c];
            }

            for (int i = 0; i < ALP; ++i) {
                if (i != c) {
                    dp[i] = max((int)(dp[i] > 0), tlrs[i]);
                }
            }

            continue;
        }

        dp[cl] = max(tlrs[cl], left_run + (dp[cl] > 0));
        dp[cr] = max(tlrs[cr], right_run + (dp[cr] > 0));

        for (int i = 0; i < ALP; ++i) {
            if (i != cl && i != cr) {
                dp[i] = max((int)(dp[i] > 0), tlrs[i]);
            }
        }
    }

    int answ = 0;
    for (int i = 0; i < ALP; ++i) {
        maxeq(answ, dp[i]);
    }

    assert(answ < MAX);

    cout << answ;

    return 0;
}
