#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


const int ALP = 26;


void subtract_a(string &s) {
    for (char &c : s) {
        c -= 'a';
    }
}


inline void maxeq(int &a, int b) {
    if (b > a) {
        a = b;
    }
}


vector<int> longest_runs(string &s) {
    s += (char)-1;

    int n = s.length();

    vector<int> res(ALP);

    char last = 0;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] != last) {
            maxeq(res[last], cnt);

            last = s[i];
            cnt = 0;
        }

        ++cnt;
    }

    return res;
}


struct State {
    int left, lrun, right, rrun;
    vector<int> dp;
    bool same;

    State() : dp(ALP) {};

    State(string s) {
        int m = s.length();

        subtract_a(s);

        left = s[0];
        for (lrun = 0; lrun < m && s[lrun] == left; ++lrun);

        right = s[m - 1];
        for (rrun = 0; rrun < m && s[m - 1 - rrun] == right; ++rrun);

        dp = longest_runs(s);

        same = (lrun == m);
    }
};

State operator*(State s, State t) {
    State r;

    r.same = s.same && t.same && s.left == t.left;
    r.left = s.left;
    r.right = s.right;

    r.lrun = s.lrun;
    if (s.same && s.left == t.left) {
        r.lrun = s.lrun * (t.lrun + 1) + t.lrun;
    }

    r.rrun = s.rrun;
    if (s.same && s.right == t.right) {
        r.rrun = s.rrun * (t.rrun + 1) + t.rrun;
    }

    for (int i = 0; i < ALP; ++i) {
        r.dp[i] = s.dp[i];
    }

    if (s.left == s.right && t.dp[s.left]) {
        maxeq(r.dp[s.left], s.lrun + s.rrun + 1);
    } else {
        maxeq(r.dp[s.left], s.lrun + (t.dp[s.left] > 0));
        maxeq(r.dp[s.right], s.rrun + (t.dp[s.right] > 0));
    }

    return r;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<string> ss(n);
    for (int i = 0; i < n; ++i) {
        cin >> ss[i];
    }

    reverse(ss.begin(), ss.end());

    State cur(ss[0]);
    for (int cs = 1; cs < n; ++cs) {
        cur = cur * State(ss[cs]);
    }

    int answ = 0;
    for (int i = 0; i < ALP; ++i) {
        maxeq(answ, cur.dp[i]);
    }

    cout << answ;

    return 0;
}
