#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const string YES = "Yes";
const string NO = "No";

int n, m;
vector<string> source;

struct SolutionEssence {
    string verdict;
    int max_value;
};

SolutionEssence getSolutionEssence(InStream &in) {
    SolutionEssence result;

    pattern first_line_pattern("(" + YES + "|" + NO + ")");
    result.verdict = trim(in.readString());
    if (!first_line_pattern.matches(result.verdict)) {
        in.quitf(_pe, "First line should have only \"Yes\" or \"No\"");
    }

    if (result.verdict == YES) {
        vector<int> arr1 = in.readInts(n, 1, n + m, "first_set");
        vector<int> arr2 = in.readInts(m, 1, n + m, "second_set");

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int diff = arr1[i] - arr2[j];
                char mode = (diff == 0 ? '=' : (diff < 0 ? '<' : '>'));
                if (mode != source[i][j]) {
                    in.quitf(_wa,
                            "A[%d][%d] = \"%c\", but arr1[%d] %c arr2[%d]",
                            i + 1, j + 1, source[i][j],
                            i + 1, mode, j + 1);
                }
            }
        }
        
        result.max_value = max(
            *max_element(arr1.begin(), arr1.end()),
            *max_element(arr2.begin(), arr2.end())
        );
    }
    
    return result;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    string pattern = "[<>=]";

    n = inf.readInt();
    inf.readSpace();
    m = inf.readInt();
    inf.readEoln();
    source.resize(n);
    for (auto &it : source) {
        it = inf.readLine(pattern + "{" + to_string(m) + "}");
    }

    auto author_sol = getSolutionEssence(ans);
    auto participant_sol = getSolutionEssence(ouf);

    // author failed with the verdict
    quitif(author_sol.verdict == NO && participant_sol.verdict == YES,
        _fail, "The author doesn't have a solution, though a participant does");

    // participant failed with the verdict
    quitif(author_sol.verdict != participant_sol.verdict,
        _wa, "Participant didn't find any valid answer, but jury did", author_sol.verdict.c_str());

    // author failed with the max value
    quitif(author_sol.verdict == YES && author_sol.max_value > participant_sol.max_value,
        _fail, "Jury's answer is %d, but participant has a better answer %d",
        author_sol.max_value, participant_sol.max_value);

    // participant failed with the max value
    quitif(author_sol.verdict == YES && author_sol.max_value < participant_sol.max_value,
        _wa, "Participant's answer is %d, but jury has a better answer %d",
        participant_sol.max_value, author_sol.max_value);

    if (author_sol.verdict == YES) {
        quitf(_ok, "The answer is %d", author_sol.max_value);
    } else {
        quitf(_ok, "There is no answer");
    }
}
