#include <iostream>
#include <limits>
#include <algorithm>
#include <set>
#include <string>
#include <vector>
using namespace std;

int n, m;
vector<string> matr;

bool is_correct(const vector<int> &vec) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char needed_symbol = '=';
            if (vec[i] > vec[j + n]) {
                needed_symbol = '>';
            } else if (vec[i] < vec[j + n]) {
                needed_symbol = '<';
            }
            if (needed_symbol != matr[i][j]) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    // Input data
    cin >> n >> m;

    matr.resize(n);
    for (auto &it : matr) {
        cin >> it;
    }

    // the result arrays will have numbers from 1 to (n + m)
    vector<int> result_vec;
    int max_value = numeric_limits<int>::max();

    vector<int> vec(n + m);
    while (true) {
        if (is_correct(vec)) {
            int cur_max_value = *max_element(vec.begin(), vec.end());
            if (cur_max_value < max_value) {
                max_value = cur_max_value;
                result_vec = vec;
            }
        }

        vec.back()++;

        int pos = n + m - 1;
        while (pos > 0 && vec[pos] >= n + m) {
            vec[pos] = 0;
            vec[pos - 1]++;
            pos--;
        }
        if (vec[0] >= n + m) {
            break;
        }
    }

    if (max_value == numeric_limits<int>::max()) {
        cout << "No" << endl;
    } else {
        cout << "Yes" << endl;
        for (int i = 0; i < n; i++) {
            cout << result_vec[i] + 1 << " ";
        }
        cout << endl;
        for (int i = n; i < n + m; i++) {
            cout << result_vec[i] + 1 << " ";
        }
        cout << endl;
    }
}
