#include <cstdio>
#include <set>
#include <string>
#include <vector>
using namespace std;

int main() {
    // Input data
    int n, m;
    scanf("%d%d", &n, &m);

    char buf[1005];

    vector<string> matr(n);
    for (int i = 0; i < n; ++i) {
        scanf("%s", buf);
        matr[i] = string(buf);
    }

    // Rebuild the matrix
    vector<string> zip_matr(n + m);
    for (int i = 0; i < n + m; i++) {
        zip_matr[i].resize(n + m, '?');
    }
    for (int i = 0; i < n; i++) {
        for (int j = n; j < n + m; j++) {
            int root_a = i;
            int root_b = j;

            char new_char = matr[i][j - n];
            char &prev_char = zip_matr[root_a][root_b];
            if (prev_char != '?' && prev_char != new_char) {
                // found an error!
                printf("No\n");
                return 0;
            } else {
                prev_char = new_char;
            }
        }
    }

    // Do a greedy algo
    vector<int> links_to_children(n + m);
    vector<int> answers(n + m);
    for (int i = 0; i < n + m; i++) {
        for (int j = 0; j < n + m; j++) {
            if (zip_matr[i][j] == '>' || zip_matr[j][i] == '<') {
                links_to_children[i]++;
            }
        }
    }
    set<pair<int, int>> q;
    for (int i = 0; i < n + m; i++) {
        q.insert({links_to_children[i], i});
    }

    while (!q.empty()) {
        auto val = *q.begin();
        q.erase(q.begin());

        if (val.first != 0) {
            printf("No\n");
            return 0;
        }

        int index = val.second;
        answers[index]++;
        for (int j = 0; j < n + m; j++) {
            if (zip_matr[j][index] == '>' || zip_matr[index][j] == '<') {
                q.erase({links_to_children[j], j});
                links_to_children[j]--;
                q.insert({links_to_children[j], j});
                answers[j] = max(answers[j], answers[index]);
            }
        }
    }

    // print the answer
    printf("Yes\n");
    for (int i = 0; i < n; i++) {
        printf("%d ", answers[i]);
    }
    printf("\n");
    for (int i = n; i < n + m; i++) {
        printf("%d ", answers[i]);
    }
    printf("\n");
}
